/****************************************************************
+---------------------------------------------------------------+
|                      M A G N E T R O N                        |
|                      -----------------                        |
|                                                               |
|               Written by Steven De Toni Oct-2007              |
|                                                               |
|                This source code is Public Domain              |
+---------------------------------------------------------------+
*****************************************************************/
 
#include <stdlib.h>
#include "basic_enemy.h"
#include "level_design.h"

BasicEnemy::~BasicEnemy()
{
}

BasicEnemy::BasicEnemy (ObjectType t)
{    
    pParentLocator = NULL;

    switch (t)
    {		
		case BET_SHIPSHOT1:
			Create (GameBMResource[GR_BASIC_SHIPSHOT].pResObj);
			m_HitPoints = GameBMResource[GR_BASIC_SHIPSHOT].hitPoints;
			m_Score     = GameBMResource[GR_BASIC_SHIPSHOT].score;
			m_IsBullet    = SDL_TRUE;
			break;

		case BET_HEDGEHOG_SHOTL:
			Create (GameBMResource[GR_PLAYER_BULLET2].pResObj);
			m_HitPoints = GameBMResource[GR_PLAYER_BULLET2].hitPoints;
			m_Score     = GameBMResource[GR_PLAYER_BULLET2].score;
			m_IsBullet    = SDL_TRUE;
			break;

		case BET_HEDGEHOG_SHOTU:
			Create (GameBMResource[GR_PLAYER_BULLET1].pResObj);
			m_HitPoints = GameBMResource[GR_PLAYER_BULLET1].hitPoints;
			m_Score     = GameBMResource[GR_PLAYER_BULLET1].score;
			m_IsBullet    = SDL_TRUE;
			break;
			
		case BET_HEDGEHOG_SHOTR:
			Create (GameBMResource[GR_PLAYER_BULLET3].pResObj);
			m_HitPoints = GameBMResource[GR_PLAYER_BULLET3].hitPoints;
			m_Score     = GameBMResource[GR_PLAYER_BULLET3].score;
			m_IsBullet    = SDL_TRUE;
			break;

		case BET_HEDGEHOG:
			Create (GameBMResource[GR_BASIC_HEADGEHOG].pResObj);
			m_HitPoints = GameBMResource[GR_BASIC_HEADGEHOG].hitPoints;
			m_Score     = GameBMResource[GR_BASIC_HEADGEHOG].score;
			break;

        case BET_SHOT_REFIRE:
            Create (GameBMResource[GR_BASIC_ENENYSHOT2].pResObj);
            m_HitPoints   = GameBMResource[GR_BASIC_ENENYSHOT2].hitPoints;
		    m_Score       = GameBMResource[GR_BASIC_ENENYSHOT2].score;        
            m_IsBullet    = SDL_TRUE;
            m_FrameDelay  = 2;
            m_TimeToLive  = GameFPS.rate * 60;            
            break;

        case BET_SKULLCROSS1:
            Create (GameBMResource[GR_BASIC_SKULLCROSS].pResObj);
			m_HitPoints = GameBMResource[GR_BASIC_SKULLCROSS].hitPoints;
			m_Score     = GameBMResource[GR_BASIC_SKULLCROSS].score;
            break;

		case BET_BOSS_SHEILD_ROTATE:
            Create (GameBMResource[GR_ADV_MUTANT1].pResObj);
			m_HitPoints = GameBMResource[GR_ADV_MUTANT1].hitPoints;
			m_Score     = GameBMResource[GR_ADV_MUTANT1].score;            
			break;		


        case BET_ELECTRODE1:
            Create (GameBMResource[GR_BE_ELECTRODE1].pResObj);
			m_HitPoints = GameBMResource[GR_BE_ELECTRODE1].hitPoints;
			m_Score     = GameBMResource[GR_BE_ELECTRODE1].score;
            SetYFrameBank (rand() % 3);
            m_Frame = rand() % m_NbTotFrame; 
            break;

        case BET_BLOB_PODLETS:
            Create (GameBMResource[GR_BASIC_ENEMY_PODLETS].pResObj);
			m_HitPoints  = GameBMResource[GR_BASIC_ENEMY_PODLETS].hitPoints;
			m_Score      = GameBMResource[GR_BASIC_ENEMY_PODLETS].score;
            m_FrameDelay = 1;
            SetYFrameBank (rand() % 3);
            m_Frame = rand() % m_NbTotFrame; 
            break;

        case BET_BLOB_PODS:
            Create (GameBMResource[GR_BASIC_ENEMY_PODS].pResObj);
			m_HitPoints  = GameBMResource[GR_BASIC_ENEMY_PODS].hitPoints;
			m_Score      = GameBMResource[GR_BASIC_ENEMY_PODS].score;
            m_FrameDelay = 2;
            SetYFrameBank (rand() % 4);
            m_Frame = rand() % m_NbTotFrame; 
            break;

        case BET_BLOB_SHIP1:
            Create (GameBMResource[GR_BASIC_ENEMY5].pResObj);
			m_HitPoints  = GameBMResource[GR_BASIC_ENEMY5].hitPoints;
			m_Score      = GameBMResource[GR_BASIC_ENEMY5].score;
            break;	
            
        case BET_BLOB_SPLITTER:
            Create (GameBMResource[GR_BASIC_SPLITTER].pResObj);
			m_HitPoints  = GameBMResource[GR_BASIC_SPLITTER].hitPoints;
			m_Score      = GameBMResource[GR_BASIC_SPLITTER].score;
            m_FrameDelay = 4;
            break;	

        case BET_BLOB3:
            Create (GameBMResource[GR_BASIC_ENEMY3].pResObj);
			m_HitPoints  = GameBMResource[GR_BASIC_ENEMY3].hitPoints;
			m_Score      = GameBMResource[GR_BASIC_ENEMY3].score;
            break;	

        case BET_BLOB2:
            Create (GameBMResource[GR_BASIC_ENEMY2].pResObj);
			m_HitPoints  = GameBMResource[GR_BASIC_ENEMY2].hitPoints;
			m_Score      = GameBMResource[GR_BASIC_ENEMY2].score;
			m_FrameDelay = 20;
            break;

        case BET_BLOB1:
            Create (GameBMResource[GR_BASIC_ENEMY1].pResObj);
			m_HitPoints = GameBMResource[GR_BASIC_ENEMY1].hitPoints;
			m_Score     = GameBMResource[GR_BASIC_ENEMY1].score;
            m_FrameDelay = 20;
            break;

		case BET_SHOT1:
			Create (GameBMResource[GR_BASIC_ENEMYSHOT1].pResObj);

			m_HitPoints   = GameBMResource[GR_BASIC_ENEMYSHOT1].hitPoints;
			m_Score       = GameBMResource[GR_BASIC_ENEMYSHOT1].score;
            m_FrameDelay  = 1;
            m_IsBullet    = SDL_TRUE;
            m_TimeToLive  = GameFPS.rate * 3;
            break;
    }
    m_Type = t;
}    
    
void BasicEnemy::PlaySnd (int sndID)
{
	switch (sndID)
	{
		case SNDT_HIT:        
            SNDPlayPan (SNDCHL_MAIMEHIT, GameSNDResource[GRS_MAIMEHIT].pResSnd, 0, (int)m_PosX, (int)m_PosY); 
            break;

        case SNDT_DEATH:
            SNDPlayPan (SNDCHL_ENEMY_HIT, GameSNDResource[GRS_ENEMYHIT1].pResSnd, 0, (int)m_PosX, (int)m_PosY);
			break;
	}
}

bool BasicEnemy::MaimedHit (int shotType) 
{
    switch (m_Type)
    {
		case BET_BLOB_SPLITTER:
			if ((rand() % 3) == 2)
			{
				for (int i = 0; i < 2; i++)
				{
					SDLSprite* pNewObj = CreateNewObject (BET_BLOB_SPLITTER, LLT_ENEMY);

					PEnemyList->AddSprite (pNewObj);

					pNewObj->SetYFrameBank (GetYFrameBank());
					pNewObj->m_PosX   = m_PosX + ((m_BlockWidth/2)  + ((rand() % (m_BlockWidth*2))-m_BlockWidth));
					pNewObj->m_PosY   = m_PosY + ((m_BlockHeight/2) + ((rand() % (m_BlockWidth*2))-m_BlockWidth));
					pNewObj->m_VelX   = m_VelX;
					pNewObj->m_VelY   = m_VelY;
					pNewObj->m_VelInc = m_VelInc;
				}
			}
			break;

		case BET_HEDGEHOG:// if hit, spawn 3 bullets 
			{
				static int		   xVel[] = {-3,  0, 3, -3, 0, 3}; 
				static int	       yVel[] = {-3, -3, -3, 3, 3, 3};
				static ObjectType  ot[]   = {BET_HEDGEHOG_SHOTL, BET_HEDGEHOG_SHOTU, BET_HEDGEHOG_SHOTR,
				        				     BET_HEDGEHOG_SHOTR, BET_HEDGEHOG_SHOTU, BET_HEDGEHOG_SHOTL};
			    int idx = 0;
				int end = 3;

				switch ((ObjectType)shotType)
				{  
					case PLY_BULLET_LU:
					case PLY_BULLET_UU:
					case PLY_BULLET_RU:
					case PLY_BULLET_LL:
						idx = 3;
						end = 6;

					default:
                		for (; idx < end; idx++)
						{   
							 SDLSprite* pNewObj = CreateNewObject (ot[idx], LLT_NULL);
                 
							 PEnemyList->AddSprite (pNewObj);

							 pNewObj->m_PosX   = m_PosX + (m_BlockWidth/2);
							 pNewObj->m_PosY   = m_PosY + (m_BlockHeight/2);
							 pNewObj->m_VelX   = (float)xVel[idx];
							 pNewObj->m_VelY   = (float)yVel[idx];
							 pNewObj->m_VelInc = 0;
						}
				}
			}
			break;

		case BET_BLOB_PODS: // if hit, spawn smaller bubbles...
			{
				for (int idx = 0; idx < 6; idx++)
				{   
					 SDLSprite* pNewObj = CreateNewObject (BET_BLOB_PODLETS, LLT_ENEMY);
                 
					 PEnemyList->AddSprite (pNewObj);

					 pNewObj->SetYFrameBank (GetYFrameBank());
					 pNewObj->m_PosX   = m_PosX + ((m_BlockWidth/2)  + ((rand() % m_BlockWidth)-m_BlockWidth));
					 pNewObj->m_PosY   = m_PosY + ((m_BlockHeight/2) + ((rand() % m_BlockWidth)-m_BlockWidth));
					 pNewObj->m_VelX   = m_VelX;
					 pNewObj->m_VelY   = m_VelY;
					 pNewObj->m_VelInc = m_VelInc;
				}
			}
			break;

        case BET_SHOT_REFIRE:               
            switch ((ObjectType)shotType)
            {   
                case PLY_BULLET_LL:
                    m_VelX = 3.5f;
                    m_VelY = 0.0f;
                    SetYFrameBank (0);
                    break;
                case PLY_BULLET_LU:
                    m_VelX = 3.5f;
                    m_VelY = 3.5f;
                    SetYFrameBank (3);
                    break;
                case PLY_BULLET_UU:
                    m_VelX = 0.0f;
                    m_VelY = 3.5f;
                    SetYFrameBank (7);
                    break;
                case PLY_BULLET_RU:
                    m_VelX = -3.5f;
                    m_VelY = 3.5f;
                    SetYFrameBank (5);
                    break;
                case PLY_BULLET_RR:
                    m_VelX = -3.5f;
                    m_VelY = 0.0f;
                    SetYFrameBank (1);
                    break;
                case PLY_BULLET_RD:
                    m_VelX = -3.5f;
                    m_VelY = -3.5f;
                    SetYFrameBank (2);
                    break;
                case PLY_BULLET_DD:
                    m_VelX = 0.0f;
                    m_VelY = -3.5f;
                    SetYFrameBank (6);
                    break;
                case PLY_BULLET_LD:
                    m_VelX = 3.5f;
                    m_VelY = -3.5f;
                    SetYFrameBank (4);
                    break;
                case OBJT_NULL:
                default:
                    m_TimeToLive = 1;

            }
    }
    return false;
}

void BasicEnemy::Move (SDLSprite* pPlayer)
{
    switch (m_Type)
    {
		case BET_SHIPSHOT1:
            m_PosX += m_VelX;
			m_PosY += m_VelY;			
                        
            if (GameBoundryCheckUpdate (this) != false)
                m_TimeToLive = 1;

			m_Frame = GameFPS.currentticks % m_NbTotFrame;
			break;

        case BET_SKULLCROSS1:
            m_Frame = GameFPS.currentticks % m_NbTotFrame;
            break;

		case BET_BOSS_SHEILD_ROTATE:
			if (pParentLocator != NULL)
			{
				// check if pLockedObj is safe to use?		
				for (SDLSprite* pNode = PEnemyList->m_pList; pNode != NULL;)
				{
					if (pNode == pParentLocator)
					{
						float i = (SINCOS_TABNUM/360.0f);
						
						m_PosX = pParentLocator->m_PosX + (SIN[(int)(i * m_PosZ) % SINCOS_TABNUM] * m_VelX);
						m_PosY = pParentLocator->m_PosY + (COS[(int)(i * m_PosZ) % SINCOS_TABNUM] * m_VelX);
						m_PosZ += m_VelY;
						break;
					}

                    if (pNode != NULL)
                        pNode = pNode->m_Next;

				}
			}

            // create new shot
            if ((rand() % 300) == 100)
            {				
				SDLSprite* pShot = CreateNewObject (BET_SHOT1, LLT_NULL);
				pShot->m_PosX = m_PosX + (m_BlockWidth/2);
				pShot->m_PosY = m_PosY + (m_BlockHeight/2);

				// Calculate path to player
				pShot->m_PosZ = (float) ATAN2((pPlayer->m_PosY + (pPlayer->m_BlockHeight/2)) - pShot->m_PosY, 
										      (pPlayer->m_PosX + (pPlayer->m_BlockWidth/2))  - pShot->m_PosX);

                pShot->m_VelR = 6.0;
				PEnemyList->AddSprite (pShot);
			}

			m_Frame = GameFPS.currentticks % m_NbTotFrame;
			break;
		
		case BET_ELECTRODE1:
            // Rebound off the walls of the arena
            if ((int)m_PosY+m_BlockHeight+m_VelY > GamePlayArea.y2)
                m_VelY = -m_VelY;
            if ((int)m_PosX+m_VelX < GamePlayArea.x1)
                m_VelX = -m_VelX;
            if ((int)m_PosY+m_VelY < GamePlayArea.y1)
                 m_VelY = -m_VelY;
            if ((int)m_PosX+m_BlockWidth+m_VelX > GamePlayArea.x2)
                m_VelX = -m_VelX;

            m_PosX += m_VelX;
			m_PosY += m_VelY;	
			m_Frame = GameFPS.currentticks % m_NbTotFrame;
			break;

		case BET_HEDGEHOG_SHOTR:
		case BET_HEDGEHOG_SHOTL:
		case BET_HEDGEHOG_SHOTU:
            m_PosX += m_VelX;
			m_PosY += m_VelY;			
            m_Frame = rand() % m_NbTotFrame;
            
            if (GameBoundryCheckUpdate (this) != false)
                m_TimeToLive = 1;
			break;

        case BET_SHOT_REFIRE:
            m_PosX += m_VelX;
			m_PosY += m_VelY;			
            AnimateSprite (GameFPS.totalframecount);
            
            if (GameBoundryCheckUpdate (this) != false)
                m_TimeToLive = 1;
            break;

		case BET_HEDGEHOG:        
        case BET_BLOB_SHIP1:
		case BET_BLOB3:
			if (m_PosX-m_VelX+(m_BlockWidth/2) > pPlayer->m_PosX + (pPlayer->m_BlockWidth/2))
			{
				m_PosX = m_PosX - m_VelX;
				SetYFrameBank (1);
			}
			else if (m_PosX+m_VelX+(m_BlockWidth/2) < pPlayer->m_PosX + (pPlayer->m_BlockWidth/2))
			{
				m_PosX = m_PosX + m_VelX;
				SetYFrameBank (0);
			}

			if (m_PosY-m_VelY+(m_BlockHeight/2) > pPlayer->m_PosY + (pPlayer->m_BlockHeight/2))
				m_PosY = m_PosY - m_VelY;
			else if (m_PosY+m_VelY+(m_BlockHeight/2) < pPlayer->m_PosY + (pPlayer->m_BlockHeight/2))
				m_PosY = m_PosY + m_VelY;


			m_VelX += m_VelInc;
			m_VelY += m_VelInc;
            AnimateSprite (GameFPS.totalframecount);
			break;

        case BET_BLOB_PODLETS:
        case BET_BLOB_PODS:
        case BET_BLOB_SPLITTER:
		case BET_BLOB2:			
        case BET_BLOB1:
			if (m_PosX-m_VelX+(m_BlockWidth/2) > pPlayer->m_PosX + (pPlayer->m_BlockWidth/2))
				m_PosX = m_PosX - m_VelX;
			else if (m_PosX+m_VelX+(m_BlockWidth/2) < pPlayer->m_PosX + (pPlayer->m_BlockWidth/2))
				m_PosX = m_PosX + m_VelX;

			if (m_PosY-m_VelY+(m_BlockHeight/2) > pPlayer->m_PosY + (pPlayer->m_BlockHeight/2))
				m_PosY = m_PosY - m_VelY;
			else if (m_PosY+m_VelY+(m_BlockHeight/2) < pPlayer->m_PosY + (pPlayer->m_BlockHeight/2))
				m_PosY = m_PosY + m_VelY;

			m_VelX += m_VelInc;
			m_VelY += m_VelInc;
            AnimateSprite (GameFPS.totalframecount);
			break;

		case BET_SHOT1:
			// *** calculate radial path of shot to player ***
			if (m_PosZ < 0) 
			{   // upper/negative half of circle 
				m_PosX -= (COS[(int)((SINCOS_TABNUM/2) + m_PosZ)] * m_VelR);
				m_PosY -= (SIN[(int)((SINCOS_TABNUM/2) + m_PosZ)] * m_VelR);
			}
			else 
			{   // lower/positive half of circle
				m_PosX += (COS[(int)m_PosZ] * m_VelR);
				m_PosY += (SIN[(int)m_PosZ] * m_VelR);
			}

            AnimateSprite (GameFPS.totalframecount);
    }

    GameBoundryCheckUpdate (this);
}