#ifndef _DYNAMIC_ENEMY_
#define _DYNAMIC_ENEMY_

#include <math.h>
#include <SDL/SDL.h>
#include "lib/SDLSprite.h"
#include "lib/SDLSpriteList.h"

#include "objs.h"


class DynamicEnemy : public SDLSprite
{
public:      

    // *** Homer shot variables ***
    typedef struct 
    {
        float x, y;
        float velX, velY;
    } DM_POINTS;

    int        aimCntDwn;
    float      moveSpeed;
	int		   movePntAimRng;
    int        movePntIdx;
    int        lightningRndRng;
    int        lightningSteps;
    int        movePntsMax;
    DM_POINTS  movePos;
    DM_POINTS* movePnts;
    SDL_Rect   workRect;
    // *****************************

	DynamicEnemy (ObjectType t, char* pBonusStr = NULL);
    virtual ~DynamicEnemy();

    void setUpHomer (float x, float y);
    virtual void Draw(SDL_Surface* lpSDLS, long int ScrnWorldX = 0, long int ScrnWorldY = 0);
    virtual void Move (SDLSprite* pPlayer);
    virtual void PlaySnd (int sndID);
};

#endif
