#include <stdlib.h>
#include <memory.h>
#include <math.h> 
#include "objs.h"

#pragma warning(disable:4800) // stop complainly warning C4800: 'int' : forcing value to bool 'true' or 'false' (performance warning)

float SIN[SINCOS_TABNUM];
float COS[SINCOS_TABNUM];

// -=========================================================================-

#define GR_PLAYER         0
#define GR_PLAYER_BULLET0 1
#define GR_PLAYER_BULLET1 2
#define GR_PLAYER_BULLET2 3
#define GR_PLAYER_BULLET3 4

extern BitmapResources GameBMResource[] = 
{ 
    {NULL, _SPATH "images" _SEP "plyr_char_32_29_8_4.png",              32, 29,  8, 0x00, 0x00, 0x00, 1,   0}, // GR_PLAYER
    {NULL, _SPATH "images" _SEP "plyr_bullet_horz_8_1_6.png",           8,   1,  6, 0x00, 0x00, 0x00, 1,   0}, // GR_PLAYER_BULLET0
    {NULL, _SPATH "images" _SEP "plyr_bullet_vert_1_8_6.png",           1,   8,  6, 0x00, 0x00, 0x00, 1,   0}, // GR_PLAYER_BULLET1
    {NULL, _SPATH "images" _SEP "plyr_bullet_leftdiag_8_8_6.png",       8,   8,  6, 0x00, 0x00, 0x00, 1,   0}, // GR_PLAYER_BULLET2
    {NULL, _SPATH "images" _SEP "plyr_bullet_rightdiag_8_8_6.png",      8,   8,  6, 0x00, 0x00, 0x00, 1,   0}, // GR_PLAYER_BULLET3

    {NULL, _SPATH "images" _SEP "bug_28_25_1.png",                      28, 25,  1, 0x00, 0x00, 0x00, 1, 100}, // GR_BASIC_ENEMY1    
	{NULL, _SPATH "images" _SEP "alien_blue_30_14_6.png",               30, 14,  6, 0x00, 0x00, 0x00,  1, 600}, // GR_ADV_MUTANT1    

	{NULL, _SPATH "images" _SEP "mutant_shot_14_12_16.png",             14, 12, 16, 0x00, 0x00, 0x00,  1,	    0},// GR_BASIC_ENEMYSHOT1    
    {NULL, "",				                                            128, 128,  1, 0x00, 0x00, 0x00,  1,	  100},// GR_DYN_HOMERSHOT1    
    {NULL, _SPATH "images" _SEP "small_brain_125_125_8_2.png",          25, 25,  8, 0x00, 0x00, 0x00,  1,	  300},// GR_ADV_BRAIN1    


    {NULL, _SPATH "images" _SEP "max_walk_21_24_8_4.png",               21, 24, 8, 0x00, 0x00, 0x00,  1,	  1000},// GR_MAX    
    {NULL, _SPATH "images" _SEP "max_16_35_3_4.png",                    16, 35, 3, 0x00, 0xff, 0x00,  1,	  1000},// GR_SAM    
    {NULL, _SPATH "images" _SEP "robby_16_26_2_4.png",                  16, 26, 2, 0x00, 0xff, 0x00,  1,	  500}, // GR_ROBBY    

    {NULL, _SPATH "images" _SEP "electrode1_21_21_6_3.png",             21, 21, 6, 0x00, 0x00, 0x00,  1,     50},  // GR_BE_ELECTRODE1

    {NULL, _SPATH "images" _SEP "pow_extralife_16_16_8.png",            16, 16, 8, 0x00, 0xff, 0x00,  1,	  1000},// GR_POW_EXTRALIFE
    {NULL, _SPATH "images" _SEP "pow_3way_16_16_8.png",                 16, 16, 8, 0x00, 0xff, 0x00,  1,	  1000},// GR_POW_3FIRE
    {NULL, _SPATH "images" _SEP "pow_fasterfire_16_16_8.png",           16, 16, 8, 0x00, 0xff, 0x00,  1,	  1000},// GR_POW_FASTERFIRE    
    {NULL, _SPATH "images" _SEP "pow_smartbomb_16_16_8.png",            16, 16, 8, 0x00, 0xff, 0x00,  1,	  1000},// GR_POW_SMARTBOMB    
    {NULL, _SPATH "images" _SEP "pow_electric_16_16_8.png",             16, 16, 8, 0xff, 0xff, 0xff,  1,	  1000},// GR_POW_SHOCKBLASTER 
    {NULL, _SPATH "images" _SEP "pow_attract_16_16_8.png",              16, 16, 8, 0xff, 0x00, 0x00,  1,	  1000},// GR_POW_ATTRACTOR
    {NULL, _SPATH "images" _SEP "pow_attract_mag_7_8_1.png",             7,  8, 1, 0x00, 0x00, 0x00,  1,	  1000},// GR_POW_ATTRACTMAG 
    {NULL, _SPATH "images" _SEP "robot_cyan_23_32_4.png",               23, 32, 4, 0x00, 0x00, 0x00,  1,	   100},// GR_BASIC_ENEMY2    
    {NULL, _SPATH "images" _SEP "twins_32_30_1_2.png",                  32, 30, 1, 0x00, 0x00, 0x00,  3,	  1000},// GR_BASIC_ENEMY3
    
    {NULL, _SPATH "images" _SEP "grav_pad_27_10_4.png",                 27, 10, 4, 0x00, 0x00, 0x00,  1,	  1000},// GR_ADV_SPAWNER

	{NULL, _SPATH "images" _SEP "robot_blue_50_50_12_2.png",            50, 50, 12, 0x00, 0x00, 0x00, MAX_INT, 0}, // GR_ADV_ROBOTBULLY1
    {NULL, _SPATH "images" _SEP "skull_crossbones_32_32_4.png",         32, 32, 4,  0x00, 0x00, 0x00, MAX_INT, 0}, // GR_BASIC_SKULLCROSS

    {NULL, _SPATH "images" _SEP "shot2_blue_16_16_2_8.png",             16, 16,  2,  0x00, 0x00, 0x00, MAX_INT, 0}, // GR_BASIC_ENENYSHOT2
    {NULL, _SPATH "images" _SEP "alien_blob_green_17_16_4.png",         17, 16,  4,  0x00, 0x00, 0x00, 1,      300},// GR_BASIC_SPLITTER
    {NULL, _SPATH "images" _SEP "alien_ship_32_18_1_2.png",             32, 18,  1,  0x00, 0x00, 0x00, 1,      300},// GR_BASIC_ENEMY5
    {NULL, _SPATH "images" _SEP "impos_robot_18_21_4_2.png",            18, 21,  1,  0x00, 0x00, 0x00, 1,      300},// GR_BASIC_IMPOSROBOT1
    {NULL, _SPATH "images" _SEP "spirals_34_34_3_4.png",                34, 34,  3,  0x00, 0x00, 0x00, 1,      300},// GR_BASIC_ENEMY_PODS
    {NULL, _SPATH "images" _SEP "spirals_small_14_14_3_4.png",          14, 14,  3,  0x00, 0x00, 0x00, 1,      300},// GR_BASIC_ENEMY_PODLETS
    {NULL, _SPATH "images" _SEP "mother_bug_80_88_1.png",               80, 88,  1,  0x00, 0x00, 0x00, 300,  10000},// GR_ADV_BOSS1
    {NULL, _SPATH "images" _SEP "wench_14_26_3_4.png",                  14, 26,  3,  0x00, 0xff, 0x00,  1,	  1000},// GR_WENCH    
    {NULL, _SPATH "images" _SEP "recycle_35_33_3.png",                  35, 33,  3,  0x00, 0x00, 0x00, MAX_INT,1000},// GR_FRD_RAIN1
    {NULL, _SPATH "images" _SEP "laser_horz_59_16_1.png",               59, 16,  1,  0x00, 0x00, 0x00, MAX_INT,  0},// GR_ADV_LASER_HORZ
	{NULL, _SPATH "images" _SEP "laser_vert_16_59_1.png",               16, 59,  1,  0x00, 0x00, 0x00, MAX_INT,  0},// GR_ADV_LASER_VERT 
    {NULL, _SPATH "images" _SEP "bull_84_65_2.png",                     84, 65,  2,  0x00, 0xff, 0x00, MAX_INT,  0},// GR_ADV_BULLDROP 
	{NULL, _SPATH "images" _SEP "hedgehog_20_16_1_2.png",               20, 16,  1,  0x00, 0x00, 0x00,  1,		600},// GR_BASIC_HEADGEHOG
	{NULL, _SPATH "images" _SEP "ship_shot_9_9_3.png",                  9,   9,  3,  0x00, 0x00, 0x00,    1,        50},// GR_BASIC_SHIPSHOT
	{NULL, _SPATH "images" _SEP "orb2_61_61_1.png",                     61, 61,  1,  0x00, 0x00, 0x00,   20,	5000},// GR_ADV_ORB
	{NULL, _SPATH "images" _SEP "orb3_10_10_1.png",                     10, 10,  1,  0x00, 0x00, 0x00,   0,	   0},// GR_ADV_ORB2	
    {NULL, _SPATH "images" _SEP "orb_small_20_20_1.png",                20, 20,  1,  0x00, 0x00, 0x00,   0,	 500},// GR_ADV_ORB_SMALL	
    {NULL, _SPATH "images" _SEP "big_brain_125_125_8_2.png",          125, 125,  8,  0x00, 0x00, 0x00, 500,   20000},// GR_ADV_BIG_BRIAN	

    // ***************** list terminator *****************
    {NULL, "",					                       				 0,  0,  0, 0x00, 0x00, 0x00, 0, -314159}  
};

extern SoundResources  GameSNDResource[] = 
{
	{NULL, _SPATH "sounds" _SEP "pulse_fire.wav"},   // GRS_PLAYER_SHOOT
	{NULL, _SPATH "sounds" _SEP "death_4.wav"},      // GRS_PLAYER_DEATH
    {NULL, _SPATH "sounds" _SEP "ohyeah.wav"},       // GRS_OH_YEAH
    {NULL, _SPATH "sounds" _SEP "pickup2.wav"},      // GRS_PICKUP1
    {NULL, _SPATH "sounds" _SEP "pickup2.wav"},      // GRS_PICKUP2
    {NULL, _SPATH "sounds" _SEP "pickup4.wav"},      // GRS_PICKUP3
    {NULL, _SPATH "sounds" _SEP "hit1.wav"},         // GRS_ENEMYHIT1
    {NULL, _SPATH "sounds" _SEP "hit2.wav"},         // GRS_ENEMYDEATH1
    {NULL, _SPATH "sounds" _SEP "explodeswiv.wav"},  // GRS_SMARTBOMB1
	{NULL, _SPATH "sounds" _SEP "electricty.wav"},   // GRS_ELECTRIC1    
    {NULL, _SPATH "sounds" _SEP "oo.wav"},           // GRS_OOW
    {NULL, _SPATH "sounds" _SEP "playerup.wav"},     // GRS_PLAYERUP
	{NULL, _SPATH "sounds" _SEP "warp4.wav"},        // GRS_ENDLEVEL
    {NULL, _SPATH "sounds" _SEP "spawn1.wav"},       // GRS_MUTANTSPAWN
    {NULL, _SPATH "sounds" _SEP "electrocuted.wav"}, // GRS_ELECTRICDEATH    
    {NULL, _SPATH "sounds" _SEP "intro5.wav"},       // GRS_MENUINTRO1
    {NULL, _SPATH "sounds" _SEP "intro3.wav"},       // GRS_MENUINTRO2
    {NULL, _SPATH "sounds" _SEP "laser42.wav"},      // GRS_LASER1
    {NULL, _SPATH "sounds" _SEP "pulseBleep.wav"},   // GRS_MAIMEHIT
    {NULL, _SPATH "sounds" _SEP "splode1.wav"},      // GRS_EXPLODE1
	{NULL, _SPATH "sounds" _SEP "shoot2.wav"},       // GRS_ENEMYSHOOT1
    {NULL, _SPATH "sounds" _SEP "splode2.wav"},      // GRS_EXPLODE2

	{NULL, ""}
};

Partical::Partical ()
{
    blank ();
}

Partical::Partical (SDL_Surface* pSrcBitmap, int x, int y, int w, int h)
{
    blank ();
    assignImage (pSrcBitmap, x, y, w, h);
}

Partical::~Partical ()
{
    if (pBitmap != NULL)
        SDL_FreeSurface(pBitmap);

	if (pTrigger != NULL)
		delete pTrigger;
}

bool Partical::assignImage (SDL_Surface* pSrcBitmap, int x, int y, int w, int h)
{
    if (pBitmap != NULL)
    {
        // Can we reuse an existing image area?
        if (pBitmap->w != w || pBitmap->h != h)
        {
            SDL_FreeSurface(pBitmap);
            pBitmap = NULL;
        }
    }

    if (pBitmap == NULL)
    {
        if ((pBitmap = SDL_CreateRGBSurface (pSrcBitmap->flags, w, h, pSrcBitmap->format->BitsPerPixel, pSrcBitmap->format->Rmask, pSrcBitmap->format->Gmask, pSrcBitmap->format->Bmask, pSrcBitmap->format->Amask)) == NULL)
            return false;
    }

    SDL_Rect srcPos = {x, y, w, h}, 
             desPos = {0, 0, w, h};

    Uint32 save = pSrcBitmap->format->colorkey;

    SDL_SetColorKey (pSrcBitmap, 0, save);
    SDL_BlitSurface (pSrcBitmap, &srcPos, pBitmap, &desPos);

    SDL_SetColorKey (pBitmap,    SDL_SRCCOLORKEY, save);
    SDL_SetColorKey (pSrcBitmap, SDL_SRCCOLORKEY, save);
    return true;
}

void Partical::blank ()
{
    xSpeed   = ySpeed = x = y = 0;
    life     = 0;
    type     = PART_BASIC;
    pBitmap  = NULL;
	pTrigger = NULL;
    pNext    = NULL;
    pPrev    = NULL;
}

void Partical::releaseBitmap (void)
{
	if (pBitmap != NULL)
	{
        SDL_FreeSurface(pBitmap);
		pBitmap = NULL;
	}
}

bool Partical::show (SDL_Surface* pScreen)
{
    if ((life <= 0) && (life != -1))
        return false;

    SDL_Rect srcPos = {0, 0, pBitmap->w, pBitmap->h}, 
             desPos = {(Sint16)x, (Sint16)y, pBitmap->w, pBitmap->h};

    SDL_BlitSurface (pBitmap, &srcPos, pScreen, &desPos);
    return true;
}

bool Partical::move (void)
{
    if (life <= 0)
        return false;

	switch (type)
	{
		case PART_BASIC:
			x = (x + xSpeed);
			y = (y + ySpeed);
			break;
	}			
			
    if (life > 0)
	{
        life--;
		if ((life == 0) && (pTrigger != NULL))
        {
			ProcessParticalTrigEvent (this);
            pTrigger->type = PARTEVNT_NULL;
        }
	}
	
    return true;
}
void Partical::setTrigger (ParticalTrig* pTrigData)
{
    if (pTrigData == NULL)
        return;

	if (pTrigger == NULL)
		pTrigger = new ParticalTrig;

    *pTrigger = *pTrigData;
}

Partical* ParticalCollection::findFreeItem (void)
{
#ifdef PARTLIST_CACHE_ENABLED
    if (pCacheList != NULL)
    {
		for (Partical* pNode = pCacheList->pList; pNode != NULL;)
			return pCacheList->removeItem (pNode);			    

        return new Partical();
    }
    else
#endif
        return new Partical();
}


ParticalCollection::~ParticalCollection ()
{
    for (Partical* pNode = pList; pNode != NULL;)
        delItem (pNode);

    if (pCacheList != NULL)
        delete pCacheList;
}

Partical* ParticalCollection::addItem (Partical* pNode)
{
    if (pList == NULL)
    {
        pNode->pNext = NULL;
        pNode->pPrev = NULL;
        pList = pNode;        
    }
    else
    {
        pNode->pNext = pList;
        pNode->pPrev = pList->pPrev;
        pList->pPrev = pNode;
        pList        = pNode;        
    }

	listNo++;

    return pNode;
}

// type :
// 0 = vertical
// 1 = horizontal
// 2 = diagonal left
// 3 = diagonal right
// 4 = explode out 
bool ParticalCollection::buildExplosionSplit (SDLSprite* pSprite, PCExplodeType type, bool implode, float speedDelta, int time2Live, int blkSize, ParticalTrig* pTrigData)
{
    Partical*  pItem = NULL;
    int        idx;
    float      ySpd, xSpd;
    int        xOffset = pSprite->m_Frame * pSprite->m_BlockWidth;
 
    switch (type)
    {				
		case PC_EXPOUT:
			{
				ySpd = -(float)(pSprite->m_BlockHeight/2.0f);						
				for (int yPos = 0; yPos < pSprite->m_BlockHeight; yPos += blkSize)
				{
					xSpd = -(float)(pSprite->m_BlockWidth/2.0f);
					for (int xPos = 0; xPos < pSprite->m_BlockWidth; xPos+= blkSize)
					{							
						pItem = addNewItem (pSprite->m_Surface, xOffset + xPos, pSprite->m_PixelOffsetY + yPos, blkSize, blkSize);

						pItem->life   = time2Live;
						pItem->ySpeed = ySpd * speedDelta;
						pItem->xSpeed = xSpd * speedDelta;

						pItem->x = pSprite->m_PosX + (float)xPos;
						pItem->y = pSprite->m_PosY + (float)yPos;
						
						if (implode != false)
						{
							pItem->x += (pItem->xSpeed * time2Live);
							pItem->y += (pItem->ySpeed * time2Live);
							
							pItem->ySpeed = -pItem->ySpeed;
							pItem->xSpeed = -pItem->xSpeed;
						}

						xSpd += blkSize;
					}
					ySpd += blkSize;
				}
            }
			break;

        case PC_HORZ:
			ySpd    = 0;
			xSpd    = (float)(pSprite->m_BlockWidth/2);
            for (idx = pSprite->m_BlockWidth-1; idx >= 0; idx--)
            {
                pItem = addNewItem (pSprite->m_Surface, xOffset + idx, pSprite->m_PixelOffsetY, 1, pSprite->m_BlockHeight);                        
                
				if (implode != false)
				{
					pItem->life   = time2Live;
					pItem->ySpeed = 0.0f;
					pItem->xSpeed = 0.0f + (xSpd * speedDelta);

					pItem->x = (pSprite->m_PosX + (float)idx) + (time2Live * pItem->xSpeed);
					pItem->y = pSprite->m_PosY;
					
					pItem->xSpeed = -pItem->xSpeed;
				}
				else
				{
					pItem->x      = pSprite->m_PosX + (float)idx;
					pItem->y      = pSprite->m_PosY;
					pItem->xSpeed = 0.0f + (xSpd * speedDelta);
					pItem->ySpeed = 0.0f;
					pItem->life   = time2Live;							
				}
				xSpd--;
            }
            break;

		case PC_DIAGLEFT:			
			ySpd    = (float)(pSprite->m_BlockHeight/2);
			xSpd    = (float)(pSprite->m_BlockHeight/2);
			for (idx = pSprite->m_BlockHeight-1; idx >= 0; idx--)
            {
                pItem = addNewItem (pSprite->m_Surface, xOffset, idx+pSprite->m_PixelOffsetY, pSprite->m_BlockWidth, 1);

				if (implode != false)
				{
					pItem->life   = time2Live;
					pItem->xSpeed = 0.0f + (xSpd * speedDelta);
					pItem->ySpeed = 0.0f + (ySpd * speedDelta);

					pItem->x = (pSprite->m_PosX + (float)idx) + (time2Live * xSpd);
					pItem->y = (pSprite->m_PosY + (float)idx) + (time2Live * ySpd);
					
					pItem->ySpeed = -ySpd;
					pItem->xSpeed = -xSpd;							
				}
				else
				{
					pItem->x      = pSprite->m_PosX;
					pItem->y      = pSprite->m_PosY + (float)idx;
					pItem->xSpeed = 0.0f + (xSpd * speedDelta);
					pItem->ySpeed = 0.0f + (ySpd * speedDelta);
					pItem->life   = time2Live;
				}
				ySpd--;
				xSpd--;                        
            }
			break;

		case PC_DIAGRIGHT:
			ySpd = (float)(pSprite->m_BlockHeight/2);
			xSpd = -(float)(pSprite->m_BlockHeight/2);

			for (idx = pSprite->m_BlockHeight-1; idx >= 0; idx--)
            {
                pItem = addNewItem (pSprite->m_Surface, xOffset, idx+pSprite->m_PixelOffsetY, pSprite->m_BlockWidth, 1);

				if (implode != false)
				{
					pItem->life   = time2Live;
					pItem->xSpeed = 0.0f + (xSpd * speedDelta);
					pItem->ySpeed = 0.0f + (ySpd * speedDelta);

					pItem->x = (pSprite->m_PosX + (float)idx) + (time2Live * xSpd);
					pItem->y = (pSprite->m_PosY + (float)idx) + (time2Live * ySpd);
					
					pItem->ySpeed = -ySpd;
					pItem->xSpeed = -xSpd;
				}
				else
				{
					pItem->x      = pSprite->m_PosX;
					pItem->y      = pSprite->m_PosY + (float)idx;
					pItem->xSpeed = 0.0f + (xSpd * speedDelta);
					pItem->ySpeed = 0.0f + (ySpd * speedDelta);
					pItem->life   = time2Live;
				}
                ySpd--;
				xSpd++;
            }
			break;

        case PC_VERT:
        default:
			ySpd = (float)(pSprite->m_BlockHeight/2);
			xSpd = 0;
            for (idx = pSprite->m_BlockHeight-1; idx >= 0; idx--)
            {
                pItem = addNewItem (pSprite->m_Surface, xOffset, idx+pSprite->m_PixelOffsetY, pSprite->m_BlockWidth, 1);

				if (implode != false)
				{
					pItem->life   = time2Live;
					pItem->xSpeed = 0.0f;
					pItem->ySpeed = 0.0f + (ySpd * speedDelta);

					pItem->x = pSprite->m_PosX;
					pItem->y = (pSprite->m_PosY + (float)idx) + (time2Live * pItem->ySpeed);
					
					pItem->ySpeed = -pItem->ySpeed;
				}
				else
				{
					pItem->x      = pSprite->m_PosX;
					pItem->y      = pSprite->m_PosY + (float)idx;
					pItem->xSpeed = 0.0f;
					pItem->ySpeed = 0.0f + (ySpd * speedDelta);
					pItem->life   = time2Live;
				}
                ySpd--;
            }

    }

    // Attach a trigger to a partical
    if ((pTrigData != NULL) && (pItem != NULL))
        pItem->setTrigger (pTrigData);

    return true;
}

// -=========================================================================-

void ProcessParticalTrigEvent (Partical* pObj)
{
    switch (pObj->pTrigger->type)
    {
		case PARTEVNT_ADD2SPRITELIST:
            {
                SDLSpriteList* pList = (SDLSpriteList*)pObj->pTrigger->pListData;
			    pList->AddSprite ((SDLSprite*)pObj->pTrigger->pData);
            }
			break;

		case PARTEVNT_ADD2SPRITEARRAY:
			{
				SDLSprite** pArray = ((SDLSprite**)pObj->pTrigger->pListData);
				pArray[pObj->pTrigger->data] = (SDLSprite*)pObj->pTrigger->pData;
			}
			break;

		case PARTEVNT_SET_BOOL_DATA:
			{
				bool* pBool = (bool*)pObj->pTrigger->pData;
				*pBool = (bool)pObj->pTrigger->data;
			}
			break;

        case PARTEVNT_SET_INT_DATA:
			{
				int* pInt = (int*)pObj->pTrigger->pData;
				*pInt = pObj->pTrigger->data;
			}
			break;

    }
}

// -=========================================================================-

void BuildCosSinTable (void)
{
	float angle = 0;

	for (int idx = 0; idx < SINCOS_TABNUM; idx++)
	{
		SIN[idx] = (float)sin (angle);
		COS[idx] = (float)cos (angle);

		angle += SINCOS_RADSEGMT;		
	}
}
// -=========================================================================-

void SDL_Lightning (SDL_Surface* s, int bx1, int by1, int bx2, int by2, int steps, int range)
{
    Uint32 col1 = SDL_MapRGB (s->format, 0xff, 0xff, 0xff);
    Uint32 col2 = SDL_MapRGB (s->format, 50 - rand() % 50, 120 - rand() % 50, 230 - rand() % 50);

    float x = (float)bx2;
    float y = (float)by2;
    float x2, y2;
    float xStep = (float)(bx1-bx2)/(float)steps;
    float yStep = (float)(by1-by2)/(float)steps;

    for (int st = 0; st < steps-1; st++)
    {
        x2 = (x+xStep) + ((float)(rand()%((int)(range*2.0f))) - range);
        y2 = (y+yStep) + ((float)(rand()%((int)(range*2.0f))) - range);

        SDL_line (s, (int)x-1, (int)y+1, (int)x2-1, (int)y2+1, col2);
        SDL_line (s, (int)x+1, (int)y-1, (int)x2+1, (int)y2-1, col2);

        SDL_line (s, (int)x, (int)y, (int)x2, (int)y2, col1);

        x = x2;
        y = y2;
    }

    SDL_line (s, (int)x-1, (int)y+1,  (int)bx1-1, (int)by1+1, col2);
    SDL_line (s, (int)x+1, (int)y-1, (int)bx1+1, (int)by1-1, col2);
    SDL_line (s, (int)x,   (int)y,   (int)bx1,   (int)by1,   col1);
}

// The following code implements a Bresenham line drawing
// algorithm. There are 4 separate routines each optimized
// for one of the four pixel depths supported by SDL. SDL
// support many pixel formats, but it only support 8, 16,
// 24, and 32 bit pixels.

//----------------------------------------------------------

// Draw lines in 8 bit surfaces.

static void line8(SDL_Surface *s, 
                  int x1, int y1, 
                  int x2, int y2, 
                  Uint32 color)
{
  int d;
  int x;
  int y;
  int ax;
  int ay;
  int sx;
  int sy;
  int dx;
  int dy;

  Uint8 *lineAddr;
  Sint32 yOffset;

  dx = x2 - x1;  
  ax = abs(dx) << 1;  
  sx = sign(dx);

  dy = y2 - y1;  
  ay = abs(dy) << 1;  
  sy = sign(dy);
  yOffset = sy * s->pitch;

  x = x1;
  y = y1;

  lineAddr = ((Uint8 *)(s->pixels)) + (y * s->pitch);
  if (ax>ay)
  {                      /* x dominant */
    d = ay - (ax >> 1);
    for (;;)
    {
      *(lineAddr + x) = (Uint8)color;

      if (x == x2)
      {
        return;
      }
      if (d>=0)
      {
        y += sy;
        lineAddr += yOffset;
        d -= ax;
      }
      x += sx;
      d += ay;
    }
  }
  else
  {                      /* y dominant */
    d = ax - (ay >> 1);
    for (;;)
    {
      *(lineAddr + x) = (Uint8)color;

      if (y == y2)
      {
        return;
      }
      if (d>=0) 
      {
        x += sx;
        d -= ay;
      }
      y += sy;
      lineAddr += yOffset;
      d += ax;
    }
  }
}

//----------------------------------------------------------

// Draw lines in 16 bit surfaces. Note that this code will
// also work on 15 bit surfaces.

static void line16(SDL_Surface *s, 
                   int x1, int y1, 
                   int x2, int y2, 
                   Uint32 color)
{
  int d;
  int x;
  int y;
  int ax;
  int ay;
  int sx;
  int sy;
  int dx;
  int dy;

  Uint8 *lineAddr;
  Sint32 yOffset;

  dx = x2 - x1;  
  ax = abs(dx) << 1;  
  sx = sign(dx);

  dy = y2 - y1;  
  ay = abs(dy) << 1;  
  sy = sign(dy);
  yOffset = sy * s->pitch;

  x = x1;
  y = y1;

  lineAddr = ((Uint8 *)s->pixels) + (y * s->pitch);
  if (ax>ay)
  {                      /* x dominant */
    d = ay - (ax >> 1);
    for (;;)
    {
      *((Uint16 *)(lineAddr + (x << 1))) = (Uint16)color;

      if (x == x2)
      {
        return;
      }
      if (d>=0)
      {
        y += sy;
        lineAddr += yOffset;
        d -= ax;
      }
      x += sx;
      d += ay;
    }
  }
  else
  {                      /* y dominant */
    d = ax - (ay >> 1);
    for (;;)
    {
      *((Uint16 *)(lineAddr + (x << 1))) = (Uint16)color;

      if (y == y2)
      {
        return;
      }
      if (d>=0) 
      {
        x += sx;
        d -= ay;
      }
      y += sy;
      lineAddr += yOffset;
      d += ax;
    }
  }
}

//----------------------------------------------------------

// Draw lines in 24 bit surfaces. 24 bit surfaces require
// special handling because the pixels don't fall on even
// address boundaries. Instead of being able to store a
// single byte, word, or long you have to store 3
// individual bytes. As a result 24 bit graphics is slower
// than the other pixel sizes.

static void line24(SDL_Surface *s, 
                   int x1, int y1, 
                   int x2, int y2, 
                   Uint32 color)
{
  int d;
  int x;
  int y;
  int ax;
  int ay;
  int sx;
  int sy;
  int dx;
  int dy;

  Uint8 *lineAddr;
  Sint32 yOffset;

#if (SDL_BYTEORDER == SDL_BIG_ENDIAN)
  color <<= 8;
#endif

  dx = x2 - x1;  
  ax = abs(dx) << 1;  
  sx = sign(dx);

  dy = y2 - y1;  
  ay = abs(dy) << 1;  
  sy = sign(dy);
  yOffset = sy * s->pitch;

  x = x1;
  y = y1;

  lineAddr = ((Uint8 *)(s->pixels)) + (y * s->pitch);
  if (ax>ay)
  {                      /* x dominant */
    d = ay - (ax >> 1);
    for (;;)
    {
      Uint8 *p = (lineAddr + (x * 3));
      memcpy(p, &color, 3);

      if (x == x2)
      {
        return;
      }
      if (d>=0)
      {
        y += sy;
        lineAddr += yOffset;
        d -= ax;
      }
      x += sx;
      d += ay;
    }
  }
  else
  {                      /* y dominant */
    d = ax - (ay >> 1);
    for (;;)
    {
      Uint8 *p = (lineAddr + (x * 3));
      memcpy(p, &color, 3);

      if (y == y2)
      {
        return;
      }
      if (d>=0) 
      {
        x += sx;
        d -= ay;
      }
      y += sy;
      lineAddr += yOffset;
      d += ax;
    }
  }
}

//----------------------------------------------------------

// Draw lines in 32 bit surfaces. Note that this routine
// ignores alpha values. It writes them into the surface
// if they are included in the pixel, but does nothing
// else with them.

static void line32(SDL_Surface *s, 
                   int x1, int y1, 
                   int x2, int y2, 
                   Uint32 color)
{
  int d;
  int x;
  int y;
  int ax;
  int ay;
  int sx;
  int sy;
  int dx;
  int dy;

  Uint8 *lineAddr;
  Sint32 yOffset;


  dx = x2 - x1;  
  ax = abs(dx) << 1;  
  sx = sign(dx);

  dy = y2 - y1;  
  ay = abs(dy) << 1;  
  sy = sign(dy);
  yOffset = sy * s->pitch;

  x = x1;
  y = y1;

  lineAddr = ((Uint8 *)(s->pixels)) + (y * s->pitch);
  if (ax>ay)
  {                      /* x dominant */
    d = ay - (ax >> 1);
    for (;;)
    {
      *((Uint32 *)(lineAddr + (x << 2))) = (Uint32)color;

      if (x == x2)
      {
        return;
      }
      if (d>=0)
      {
        y += sy;
        lineAddr += yOffset;
        d -= ax;
      }
      x += sx;
      d += ay;
    }
  }
  else
  {                      /* y dominant */
    d = ax - (ay >> 1);
    for (;;)
    {
      *((Uint32 *)(lineAddr + (x << 2))) = (Uint32)color;

      if (y == y2)
      {
        return;
      }
      if (d>=0) 
      {
        x += sx;
        d -= ay;
      }
      y += sy;
      lineAddr += yOffset;
      d += ax;
    }
  }
}

//----------------------------------------------------------

// Examine the depth of a surface and select a line
// drawing routine optimized for the bytes/pixel of the
// surface.

void SDL_line(SDL_Surface *s, int x1, int y1, int x2, int y2, Uint32 color)
{
    if (x1 < 0)    x1 = 0;
    if (x1 >= s->w) x1 = s->w-1;

    if (x2 >= s->w) x2 = s->w-1;
    if (x2 < 0)     x2 = 0;

    if (y1 < 0) y1 = 0;
    if (y1 >= s->h) y1 = s->h-1;

    if (y2 >= s->h) y2 = s->h-1;
    if (y2 < 0) y2 = 0;


    switch (s->format->BytesPerPixel)
    {
        case 1:
            line8(s, x1, y1, x2, y2, color);
            break;
        case 2:
            line16(s, x1, y1, x2, y2, color);
            break;
        case 3:
            line24(s, x1, y1, x2, y2, color);
            break;
        case 4:
            line32(s, x1, y1, x2, y2, color);
            break;
    }
}

void DrawPixel(SDL_Surface* pScreen, int x, int y, Uint8 R, Uint8 G, Uint8 B)
{
    Uint32 color = SDL_MapRGB(pScreen->format, R, G, B);

    switch (pScreen->format->BytesPerPixel)
    {
        case 1:                                   // Assuming 8-bpp
            {
                Uint8 *bufp;
                bufp = (Uint8 *)pScreen->pixels + y*pScreen->pitch + x;
                *bufp = (Uint8)color;
            }
            break;
        case 2:                                   // Probably 15-bpp or 16-bpp
            {
                Uint16 *bufp;
                bufp = (Uint16 *)pScreen->pixels + y*pScreen->pitch/2 + x;
                *bufp = (Uint16)color;
            }
            break;
        case 3:                                   // Slow 24-bpp mode, usually not used
            {
                Uint8 *bufp;
                bufp = (Uint8 *)pScreen->pixels + y*pScreen->pitch + x * 3;
                if(SDL_BYTEORDER == SDL_LIL_ENDIAN)
                {
                    bufp[0] = (Uint8)color;
                    bufp[1] = (Uint8)color >> 8;
                    bufp[2] = (Uint8)color >> 16;
                }
                else
                {
                    bufp[2] = (Uint8)color;
                    bufp[1] = (Uint8)color >> 8;
                    bufp[0] = (Uint8)color >> 16;
                }
            }
            break;
        case 4:                                   // Probably 32-bpp
            {
                Uint32 *bufp;
                bufp = (Uint32 *)pScreen->pixels + y*pScreen->pitch/4 + x;
                *bufp = (Uint32)color;
            }
            break;
    }
}

void SNDPlayPan (int channel, Mix_Chunk* chunk, int loops, int xPos, int yPos)
{
    int   xOrigin = (PScreen->w/2);
    float inc     = 255.0f / ((float)xOrigin);
    int left, right;

    if (xPos < xOrigin)
    {
        left  = 255;
        right = 255 - (int)(inc * (float)abs(xOrigin - xPos));
    }
    else
    {
        right = 255;
        left  = 255 - (int)(inc * (float)abs(xOrigin - xPos));
    }

    Mix_PlayChannel (channel, chunk, loops);
    Mix_SetPanning  (channel, left, right);           
}

// -==========================================================================================-
#if defined(ARCH_X86)
#    define FASTDIV(a,b) \
     ({\
         int ret,dmy;\
         asm volatile(\
            "mull %3"\
            :"=d"(ret),"=a"(dmy)\
            :"1"(a),"g"(ff_inverse[b])\
             );\
        ret;\
     })
#else
#    define FASTDIV(a,b)   ((a)/(b))
#endif

int sqrt_tab[256];

void SQRTIntInit (void)
{
    for(int i=0; i<=256; i++)
    {
        sqrt_tab[i] = i==255 ? 255 : (int)(sqrt((float)i)*16+0.3);
    }
}

unsigned int SQRTInt (unsigned int a)
{
    unsigned int b;

    if(a<(1<<16)){
        if(a<(1<<10)-3)      b=sqrt_tab[(a+ 3)>>2 ]>>3;
        else{
            if(a<(1<<14)-28) b=sqrt_tab[(a+28)>>6 ]>>1;
            else             b=sqrt_tab[ a    >>8 ];
        }
    }else{
        if(a<(1<<24)){
            if(a<(1<<20)){
                b=sqrt_tab[a>>12];
                b= (FASTDIV(a,b)>>3) + (b<<1);
            }else{
                b=sqrt_tab[a>>16];
                b= (FASTDIV(a,b)>>5) + (b<<3);
            }
        }else{
            if(a<(1<<28)){
                if(a<(1<<26)){
                    b=sqrt_tab[a>>18];
                    b= (FASTDIV(a,b)>>6) + (b<<4);
                }else{
                    b=sqrt_tab[a>>20];
                    b= (FASTDIV(a,b)>>7) + (b<<5);
                }
            }else{
                if(a<(1<<30)){
                    b=sqrt_tab[a>>22];
                    b= (FASTDIV(a,b)>>8) + (b<<6);
                }else{
                    b=sqrt_tab[a>>24];
                    b= (FASTDIV(a,b)>>9) + (b<<7);
                }
            }
        }
    }

    if(a<b*b) b--;

    return b;
}
