#ifndef _WALKEROBJECTS_
#define _WALKEROBJECTS_

#include <math.h>
#include <SDL/SDL.h>
#include "lib/SDLSprite.h"
#include "lib/SDLSpriteList.h"

#include "objs.h"
#include "dynamic_enemy.h"

class WalkerObject  : public SDLSprite
{
public:
	int		   dirSpriteIdx;
	int		   direction; // 0 == stop, 1 = left, 2 = up, 3 = right, 4 = down
	int		   dirChgTimer;
    int        powBlinkTime;
	bool	   attractMode;

	DynamicEnemy* pHomer;
	bool		  homerInit;
	
	WalkerObject  (ObjectType t);
	virtual ~WalkerObject ();

	virtual void Draw(SDL_Surface* lpSDLS, long int ScrnWorldX = 0, long int ScrnWorldY = 0);

	void setAttartMode (bool mode);
	virtual void Move	   (SDLSprite* pPlayer);	
	virtual void PlaySnd   (int sndID);
};

#endif
